diff --git a/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java b/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
index 8d45fd1108d812397d3f6e624f602fb4077a371c..7b3faa1d374c142d8067f8e31b438bb90077e399 100644
--- a/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
+++ b/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
@@ -74,14 +74,17 @@ public class CertificatePoliciesExtension extends Extension
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream os = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream os = new DerOutputStream();) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        for (int i = 0; i < mInfos.size(); i++) {
-            mInfos.elementAt(i).encode(tmp);
+            for (int i = 0; i < mInfos.size(); i++) {
+                mInfos.elementAt(i).encode(tmp);
+            }
+            os.write(DerValue.tag_Sequence, tmp);
+            extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        os.write(DerValue.tag_Sequence, tmp);
-        extensionValue = os.toByteArray();
     }
 
     public CertificatePoliciesExtension(boolean critical, Vector<CertificatePolicyInfo> infos) throws IOException {
diff --git a/base/util/src/netscape/security/x509/CertificateValidity.java b/base/util/src/netscape/security/x509/CertificateValidity.java
index ae24979c5d07eb4875d59ca3bb412932e6fb37cd..27accc1162187e5c6f73743c2e6737531b5b15ca 100644
--- a/base/util/src/netscape/security/x509/CertificateValidity.java
+++ b/base/util/src/netscape/security/x509/CertificateValidity.java
@@ -169,29 +169,30 @@ public class CertificateValidity implements CertAttrSet, Serializable {
      * @exception IOException on errors.
      */
     public void encode(OutputStream out) throws IOException {
-
         // in cases where default constructor is used check for
         // null values
         if (notBefore == null || notAfter == null) {
             throw new IOException("CertAttrSet:CertificateValidity:" +
-                                  " null values to encode.\n");
+                    " null values to encode.\n");
         }
-        DerOutputStream pair = new DerOutputStream();
+        try (DerOutputStream pair = new DerOutputStream();
+                DerOutputStream seq = new DerOutputStream()) {
+            if (notBefore.getTime() < YR_2050) {
+                pair.putUTCTime(notBefore);
+            } else
+                pair.putGeneralizedTime(notBefore);
 
-        if (notBefore.getTime() < YR_2050) {
-            pair.putUTCTime(notBefore);
-        } else
-            pair.putGeneralizedTime(notBefore);
+            if (notAfter.getTime() < YR_2050) {
+                pair.putUTCTime(notAfter);
+            } else {
+                pair.putGeneralizedTime(notAfter);
+            }
+            seq.write(DerValue.tag_Sequence, pair);
 
-        if (notAfter.getTime() < YR_2050) {
-            pair.putUTCTime(notAfter);
-        } else {
-            pair.putGeneralizedTime(notAfter);
+            out.write(seq.toByteArray());
+        } catch (IOException e) {
+            throw e;
         }
-        DerOutputStream seq = new DerOutputStream();
-        seq.write(DerValue.tag_Sequence, pair);
-
-        out.write(seq.toByteArray());
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/CertificateVersion.java b/base/util/src/netscape/security/x509/CertificateVersion.java
index 5cc260d7717f87edcdaff6dcde55aebb8e7ff680..890cd7b9773f6599bc50d3de4b0440547fc6b39e 100644
--- a/base/util/src/netscape/security/x509/CertificateVersion.java
+++ b/base/util/src/netscape/security/x509/CertificateVersion.java
@@ -160,14 +160,17 @@ public class CertificateVersion implements CertAttrSet {
         if (version == V1) {
             return;
         }
-        DerOutputStream tmp = new DerOutputStream();
-        tmp.putInteger(new BigInt(version));
+        try (DerOutputStream tmp = new DerOutputStream();
+                DerOutputStream seq = new DerOutputStream()) {
+            tmp.putInteger(new BigInt(version));
 
-        DerOutputStream seq = new DerOutputStream();
-        seq.write(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 0),
-                  tmp);
+            seq.write(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 0),
+                    tmp);
 
-        out.write(seq.toByteArray());
+            out.write(seq.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java b/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
index 4b64d59a93ac15b74d38eb03982c775aaa83fe23..02e91914cb7a4f39dede9f6c252aac6553bc271d 100755
--- a/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
+++ b/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
@@ -73,9 +73,12 @@ public class DeltaCRLIndicatorExtension extends Extension
     private void encodeThis() throws IOException {
         if (baseCRLNumber == null)
             throw new IOException("Unintialized delta CRL indicator extension");
-        DerOutputStream os = new DerOutputStream();
-        os.putInteger(this.baseCRLNumber);
-        this.extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putInteger(this.baseCRLNumber);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/Extensions.java b/base/util/src/netscape/security/x509/Extensions.java
index 109f795e906dfcba8eacd84cf905681ee901533c..c6173e659b2af1fcdbf2f9baf07bda0541320c8e 100644
--- a/base/util/src/netscape/security/x509/Extensions.java
+++ b/base/util/src/netscape/security/x509/Extensions.java
@@ -162,10 +162,13 @@ public class Extensions extends Vector<Extension>
                 throw new CertificateException("Invalid extension object");
         }
 
-        DerOutputStream seq = new DerOutputStream();
-        seq.write(DerValue.tag_Sequence, extOut);
+        try (DerOutputStream seq = new DerOutputStream()) {
+            seq.write(DerValue.tag_Sequence, extOut);
 
-        out.write(seq.toByteArray());
+            out.write(seq.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/HoldInstructionExtension.java b/base/util/src/netscape/security/x509/HoldInstructionExtension.java
index 82e8475af4dfed4cdd62c56215facec6f5f066ec..5aa9bf1255cc484771b0c3f1949dbfd258135abc 100644
--- a/base/util/src/netscape/security/x509/HoldInstructionExtension.java
+++ b/base/util/src/netscape/security/x509/HoldInstructionExtension.java
@@ -113,9 +113,13 @@ public class HoldInstructionExtension extends Extension
     private void encodeThis() throws IOException {
         if (holdInstructionCodeOID == null)
             throw new IOException("Unintialized hold instruction extension");
-        DerOutputStream os = new DerOutputStream();
-        os.putOID(holdInstructionCodeOID);
-        this.extensionValue = os.toByteArray();
+
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putOID(holdInstructionCodeOID);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/InvalidityDateExtension.java b/base/util/src/netscape/security/x509/InvalidityDateExtension.java
index 8a973038597f2039e86d5c7a73d78cab5d5fefdd..e667f5530c027c62ae3319b88ccee9ad6b137e1b 100755
--- a/base/util/src/netscape/security/x509/InvalidityDateExtension.java
+++ b/base/util/src/netscape/security/x509/InvalidityDateExtension.java
@@ -74,9 +74,12 @@ public class InvalidityDateExtension extends Extension
     private void encodeThis() throws IOException {
         if (invalidityDate == null)
             throw new IOException("Unintialized invalidity date extension");
-        DerOutputStream os = new DerOutputStream();
-        os.putGeneralizedTime(this.invalidityDate);
-        this.extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putGeneralizedTime(this.invalidityDate);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/KeyUsageExtension.java b/base/util/src/netscape/security/x509/KeyUsageExtension.java
index 8cbfc880aed6ecb33aab628357536e6f1e12918d..6e5c3d82c394fa857b51175eaf00caeb1acf1e3a 100644
--- a/base/util/src/netscape/security/x509/KeyUsageExtension.java
+++ b/base/util/src/netscape/security/x509/KeyUsageExtension.java
@@ -99,9 +99,12 @@ public class KeyUsageExtension extends Extension
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream os = new DerOutputStream();
-        os.putUnalignedBitString(this.bitString);
-        this.extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putUnalignedBitString(this.bitString);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/NSCCommentExtension.java b/base/util/src/netscape/security/x509/NSCCommentExtension.java
index 6ba4775049ec2f401ccd139864cda27b88977f15..62ff39dc43caebd64497c1745f2c2bd54e20e854 100644
--- a/base/util/src/netscape/security/x509/NSCCommentExtension.java
+++ b/base/util/src/netscape/security/x509/NSCCommentExtension.java
@@ -63,12 +63,14 @@ public class NSCCommentExtension extends Extension implements CertAttrSet {
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream os = new DerOutputStream();
-
-        os.putIA5String(mComment);
-        // DerOutputStream tmp = new DerOutputStream();
-        // os.write(DerValue.tag_Sequence,tmp);
-        extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putIA5String(mComment);
+            // DerOutputStream tmp = new DerOutputStream();
+            // os.write(DerValue.tag_Sequence,tmp);
+            extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/NameConstraintsExtension.java b/base/util/src/netscape/security/x509/NameConstraintsExtension.java
index 87309080b4574534b84a117732b4f9513f40c40e..66145bf6793f15ee744de10909606d77fdeddad7 100644
--- a/base/util/src/netscape/security/x509/NameConstraintsExtension.java
+++ b/base/util/src/netscape/security/x509/NameConstraintsExtension.java
@@ -85,26 +85,29 @@ public class NameConstraintsExtension extends Extension implements CertAttrSet {
 
     // Encode this extension value.
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream()) {
 
-        DerOutputStream tagged = new DerOutputStream();
-        if ((permitted != null) && (permitted.getSubtrees().size() > 0)) {
-            DerOutputStream tmp = new DerOutputStream();
-            permitted.encode(tmp);
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, TAG_PERMITTED), tmp);
-        }
-        if ((excluded != null) && (excluded.getSubtrees().size() > 0)) {
-            DerOutputStream tmp = new DerOutputStream();
-            excluded.encode(tmp);
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 true, TAG_EXCLUDED), tmp);
-        }
-        if (permitted == null && excluded == null) {
-            extensionValue = null; // no need to encode this extension
-        } else {
-            seq.write(DerValue.tag_Sequence, tagged);
-            this.extensionValue = seq.toByteArray();
+            DerOutputStream tagged = new DerOutputStream();
+            if ((permitted != null) && (permitted.getSubtrees().size() > 0)) {
+                DerOutputStream tmp = new DerOutputStream();
+                permitted.encode(tmp);
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        true, TAG_PERMITTED), tmp);
+            }
+            if ((excluded != null) && (excluded.getSubtrees().size() > 0)) {
+                DerOutputStream tmp = new DerOutputStream();
+                excluded.encode(tmp);
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        true, TAG_EXCLUDED), tmp);
+            }
+            if (permitted == null && excluded == null) {
+                extensionValue = null; // no need to encode this extension
+            } else {
+                seq.write(DerValue.tag_Sequence, tagged);
+                this.extensionValue = seq.toByteArray();
+            }
+        } catch (IOException e) {
+            throw e;
         }
     }
 
diff --git a/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java b/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
index abf46e42815ce30f3d7300d78f4e70f53ee8d927..4f034b4999c2dfc0a77241a5e7d5963770b2d3f3 100644
--- a/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
+++ b/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
@@ -79,23 +79,26 @@ public class PolicyConstraintsExtension extends Extension
 
     // Encode this extension value.
     private void encodeThis() throws IOException {
-        DerOutputStream tagged = new DerOutputStream();
-        DerOutputStream seq = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream()) {
+            DerOutputStream tagged = new DerOutputStream();
 
-        if (require != -1) {
-            DerOutputStream tmp = new DerOutputStream();
-            tmp.putInteger(new BigInt(require));
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                         false, TAG_REQUIRE), tmp);
+            if (require != -1) {
+                DerOutputStream tmp = new DerOutputStream();
+                tmp.putInteger(new BigInt(require));
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        false, TAG_REQUIRE), tmp);
+            }
+            if (inhibit != -1) {
+                DerOutputStream tmp = new DerOutputStream();
+                tmp.putInteger(new BigInt(inhibit));
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        false, TAG_INHIBIT), tmp);
+            }
+            seq.write(DerValue.tag_Sequence, tagged);
+            extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        if (inhibit != -1) {
-            DerOutputStream tmp = new DerOutputStream();
-            tmp.putInteger(new BigInt(inhibit));
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                         false, TAG_INHIBIT), tmp);
-        }
-        seq.write(DerValue.tag_Sequence, tagged);
-        extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/PolicyMappingsExtension.java b/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
index 458e32d4a5bedc3594c5ee0b8bbb3a30b39bf317..35db8869d8f5a32c6affd64debfa87c7f1c25a3c 100644
--- a/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
+++ b/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
@@ -69,14 +69,17 @@ public class PolicyMappingsExtension extends Extension
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream os = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream os = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        for (int i = 0; i < maps.size(); i++) {
-            maps.elementAt(i).encode(tmp);
+            for (int i = 0; i < maps.size(); i++) {
+                maps.elementAt(i).encode(tmp);
+            }
+            os.write(DerValue.tag_Sequence, tmp);
+            extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        os.write(DerValue.tag_Sequence, tmp);
-        extensionValue = os.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java b/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
index 80af3d1c41fcf5706d9c417c27bdce484fe48893..89e01981c7794fbe92e7cdf133b8d3bc43ad6dd5 100644
--- a/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
+++ b/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
@@ -81,23 +81,26 @@ public class PrivateKeyUsageExtension extends Extension
 
     // Encode this extension value.
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
+        try (DerOutputStream seq = new DerOutputStream()) {
 
-        DerOutputStream tagged = new DerOutputStream();
-        if (notBefore != null) {
-            DerOutputStream tmp = new DerOutputStream();
-            tmp.putGeneralizedTime(notBefore);
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 false, TAG_BEFORE), tmp);
+            DerOutputStream tagged = new DerOutputStream();
+            if (notBefore != null) {
+                DerOutputStream tmp = new DerOutputStream();
+                tmp.putGeneralizedTime(notBefore);
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        false, TAG_BEFORE), tmp);
+            }
+            if (notAfter != null) {
+                DerOutputStream tmp = new DerOutputStream();
+                tmp.putGeneralizedTime(notAfter);
+                tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        false, TAG_AFTER), tmp);
+            }
+            seq.write(DerValue.tag_Sequence, tagged);
+            extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        if (notAfter != null) {
-            DerOutputStream tmp = new DerOutputStream();
-            tmp.putGeneralizedTime(notAfter);
-            tagged.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                 false, TAG_AFTER), tmp);
-        }
-        seq.write(DerValue.tag_Sequence, tagged);
-        extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/RevokedCertImpl.java b/base/util/src/netscape/security/x509/RevokedCertImpl.java
index eac11f8e3f13e088cd8ebcc9c1e6e37c5772363c..a54c4471ab8bebd0ecf6d6da583f6b1b4695b6b6 100755
--- a/base/util/src/netscape/security/x509/RevokedCertImpl.java
+++ b/base/util/src/netscape/security/x509/RevokedCertImpl.java
@@ -225,7 +225,7 @@ public class RevokedCertImpl extends RevokedCertificate implements Serializable
      */
     public void encode(DerOutputStream outStrm) throws CRLException,
             X509ExtensionException {
-        try {
+        try (DerOutputStream seq = new DerOutputStream()) {
             if (revokedCert == null) {
                 DerOutputStream tmp = new DerOutputStream();
                 // sequence { serialNumber, revocationDate, extensions }
@@ -237,7 +237,6 @@ public class RevokedCertImpl extends RevokedCertificate implements Serializable
                 if (extensions != null)
                     extensions.encode(tmp, isExplicit);
 
-                DerOutputStream seq = new DerOutputStream();
                 seq.write(DerValue.tag_Sequence, tmp);
 
                 revokedCert = seq.toByteArray();
@@ -348,7 +347,7 @@ public class RevokedCertImpl extends RevokedCertificate implements Serializable
     public byte[] getExtensionValue(String oid) {
         if (extensions == null)
             return null;
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             String extAlias = OIDMap.getName(new ObjectIdentifier(oid));
             Extension crlExt = null;
 
@@ -372,7 +371,6 @@ public class RevokedCertImpl extends RevokedCertificate implements Serializable
             if (extData == null)
                 return null;
 
-            DerOutputStream out = new DerOutputStream();
             out.putOctetString(extData);
             return out.toByteArray();
         } catch (Exception e) {
diff --git a/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java b/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
index 42ef26aa932d3ce905f6ebee14511abd2721d451..7e3c2734fb98b125f7ad026ee511e2f244294582 100644
--- a/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
+++ b/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
@@ -81,18 +81,21 @@ public class SubjectDirAttributesExtension extends Extension
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        //encoding the attributes
-        Enumeration<Attribute> attrs = attrList.elements();
-        while (attrs.hasMoreElements()) {
-            Attribute attr = attrs.nextElement();
-            attr.encode(tmp);
+            //encoding the attributes
+            Enumeration<Attribute> attrs = attrList.elements();
+            while (attrs.hasMoreElements()) {
+                Attribute attr = attrs.nextElement();
+                attr.encode(tmp);
+            }
+
+            out.write(DerValue.tag_SequenceOf, tmp);
+            this.extensionValue = out.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-
-        out.write(DerValue.tag_SequenceOf, tmp);
-        this.extensionValue = out.toByteArray();
     }
 
     // Decode this extension value
diff --git a/base/util/src/netscape/security/x509/X500Name.java b/base/util/src/netscape/security/x509/X500Name.java
index d0111a27e04e98a4db6a4ee44fc8324595678bf5..42cc8d829d5ae81d80eadb3e0cdb5408f1dfb8d5 100644
--- a/base/util/src/netscape/security/x509/X500Name.java
+++ b/base/util/src/netscape/security/x509/X500Name.java
@@ -591,23 +591,25 @@ public class X500Name implements Principal, GeneralNameInterface {
      *         null if no names are present.
      */
     public byte[] getEncoded() throws IOException {
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+            int len = 0;
 
-        int len = 0;
+            if (names == null) {
+                len = 0;
+            } else {
+                len = names.length;
+            }
 
-        if (names == null) {
-            len = 0;
-        } else {
-            len = names.length;
+            for (int i = 0; i < len; i++)
+                names[i].encode(tmp);
+
+            out.write(DerValue.tag_Sequence, tmp);
+            return out.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-
-        for (int i = 0; i < len; i++)
-            names[i].encode(tmp);
-
-        out.write(DerValue.tag_Sequence, tmp);
-        return out.toByteArray();
     }
 
     /*
diff --git a/base/util/src/netscape/security/x509/X509CRLImpl.java b/base/util/src/netscape/security/x509/X509CRLImpl.java
index 843cba8e2a40746944d08cdaabaf16e867b18524..dfc1017bce80d02927c7c968e4b8d4c00b6285f1 100755
--- a/base/util/src/netscape/security/x509/X509CRLImpl.java
+++ b/base/util/src/netscape/security/x509/X509CRLImpl.java
@@ -326,10 +326,9 @@ public class X509CRLImpl extends X509CRL {
      */
     public void encodeInfo(OutputStream out)
             throws CRLException, X509ExtensionException {
-        try {
+        try (DerOutputStream seq = new DerOutputStream()) {
             DerOutputStream tmp = new DerOutputStream();
             DerOutputStream rCerts = new DerOutputStream();
-            DerOutputStream seq = new DerOutputStream();
 
             if (version != 0) // v2 crl encode version
                 tmp.putInteger(new BigInt(version));
@@ -476,7 +475,7 @@ public class X509CRLImpl extends X509CRL {
     public void sign(PrivateKey key, String algorithm, String provider)
             throws CRLException, NoSuchAlgorithmException, InvalidKeyException,
             NoSuchProviderException, SignatureException, X509ExtensionException {
-        try {
+        try (DerOutputStream out = new DerOutputStream()){
             if (readOnly)
                 throw new CRLException("cannot over-write existing CRL");
             Signature sigEngine = null;
@@ -491,7 +490,6 @@ public class X509CRLImpl extends X509CRL {
             sigAlgId = AlgorithmId.get(sigEngine.getAlgorithm());
             infoSigAlgId = sigAlgId;
 
-            DerOutputStream out = new DerOutputStream();
             DerOutputStream tmp = new DerOutputStream();
 
             // encode crl info
@@ -848,7 +846,7 @@ public class X509CRLImpl extends X509CRL {
     public byte[] getExtensionValue(String oid) {
         if (extensions == null)
             return null;
-        try {
+        try (DerOutputStream out = new DerOutputStream()) {
             String extAlias = OIDMap.getName(new ObjectIdentifier(oid));
             Extension crlExt = null;
 
@@ -871,7 +869,7 @@ public class X509CRLImpl extends X509CRL {
             byte[] extData = crlExt.getExtensionValue();
             if (extData == null)
                 return null;
-            DerOutputStream out = new DerOutputStream();
+
             out.putOctetString(extData);
             return out.toByteArray();
         } catch (Exception e) {
diff --git a/base/util/src/netscape/security/x509/X509Cert.java b/base/util/src/netscape/security/x509/X509Cert.java
index 021cae2070580dd45ce2d290daebe59c8e9d37b3..351d4edf5dc14b0a0901302e5cf728ecf0687a93 100644
--- a/base/util/src/netscape/security/x509/X509Cert.java
+++ b/base/util/src/netscape/security/x509/X509Cert.java
@@ -805,24 +805,27 @@ public class X509Cert implements Certificate, Serializable {
          * Encode the to-be-signed data, then the algorithm used
          * to create the signature.
          */
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        tmp.write(data);
-        issuer.getAlgorithmId().encode(tmp);
+            tmp.write(data);
+            issuer.getAlgorithmId().encode(tmp);
 
-        /*
-         * Create and encode the signature itself.
-         */
-        issuer.update(data, 0, data.length);
-        signature = issuer.sign();
-        tmp.putBitString(signature);
+            /*
+             * Create and encode the signature itself.
+             */
+            issuer.update(data, 0, data.length);
+            signature = issuer.sign();
+            tmp.putBitString(signature);
 
-        /*
-         * Wrap the signed data in a SEQUENCE { data, algorithm, sig }
-         */
-        out.write(DerValue.tag_Sequence, tmp);
-        return out.toByteArray();
+            /*
+             * Wrap the signed data in a SEQUENCE { data, algorithm, sig }
+             */
+            out.write(DerValue.tag_Sequence, tmp);
+            return out.toByteArray();
+        } catch (IOException | SignatureException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/X509CertImpl.java b/base/util/src/netscape/security/x509/X509CertImpl.java
index 2d24b66590c1957a09665e78c6382a69a8cfe797..111cd3b6d07c7118d28adb63594f1baafae1d08e 100755
--- a/base/util/src/netscape/security/x509/X509CertImpl.java
+++ b/base/util/src/netscape/security/x509/X509CertImpl.java
@@ -405,7 +405,7 @@ public class X509CertImpl extends X509Certificate
     public void sign(PrivateKey key, String algorithm, String provider)
             throws CertificateException, NoSuchAlgorithmException,
             InvalidKeyException, NoSuchProviderException, SignatureException {
-        try {
+        try (DerOutputStream out = new DerOutputStream()){
             if (readOnly)
                 throw new CertificateEncodingException(
                               "cannot over-write existing certificate");
@@ -420,7 +420,6 @@ public class X509CertImpl extends X509Certificate
             // in case the name is reset
             algId = AlgorithmId.get(sigEngine.getAlgorithm());
 
-            DerOutputStream out = new DerOutputStream();
             DerOutputStream tmp = new DerOutputStream();
 
             // encode certificate info
diff --git a/base/util/test/com/netscape/security/util/StringTestUtil.java b/base/util/test/com/netscape/security/util/StringTestUtil.java
index 16810581cbad55f7326025a250304cb1ade75538..1d25debc342d62695c616c651512bde2782c1eda 100644
--- a/base/util/test/com/netscape/security/util/StringTestUtil.java
+++ b/base/util/test/com/netscape/security/util/StringTestUtil.java
@@ -31,29 +31,35 @@ public class StringTestUtil {
 
     public static byte[] normalizeUnicode(byte[] data) throws Exception {
 
-        DerValue value = new DerValue(data);
-        byte[] tmp = value.data.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            DerValue value = new DerValue(data);
+            byte[] tmp = value.data.toByteArray();
 
-        if (tmp[0] == -2 && tmp[1] == -1) { // remove optional big-endian byte-order mark
+            if (tmp[0] == -2 && tmp[1] == -1) { // remove optional big-endian byte-order mark
 
-            byte tag = value.tag;
-            int length = value.length() - 2;
+                byte tag = value.tag;
+                int length = value.length() - 2;
 
-            DerOutputStream os = new DerOutputStream();
-            os.putTag((byte) 0, false, tag);
-            os.putLength(length);
-            os.write(tmp, 2, length);
+                os.putTag((byte) 0, false, tag);
+                os.putLength(length);
+                os.write(tmp, 2, length);
 
-            return os.toByteArray();
+                return os.toByteArray();
+            }
+
+            return data;
+        } catch (Exception e) {
+            throw e;
         }
-
-        return data;
     }
 
     public static byte[] encode(byte tag, String string) throws Exception {
-        DerOutputStream os = new DerOutputStream();
-        os.putStringType(tag, string);
-        return os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putStringType(tag, string);
+            return os.toByteArray();
+        } catch (Exception e) {
+            throw e;
+        }
     }
 
     public static String decode(byte tag, byte[] bytes) throws Exception {
-- 
1.8.1.2

